#include "fitfreq.h"
#include <math.h>

extern int numruns,numallele;
extern int *allelesize;
extern double *expge;
extern int *replicates;
extern int **tableofalleles;
extern int progenitors[2];



void est_var_freq(double *est_mu,double *var_mu, double *est_freq, double *var_freq, double *sd_freq)
{
	double tot_mu_est, tot_mu_var, varx, vary, x,y;
	int i;
	tot_mu_est=0;
	for(i=0;i<numallele;i++)
		tot_mu_est+=est_mu[i];
	tot_mu_var=0;
	for(i=0;i<numallele;i++)
		tot_mu_var+=var_mu[i];
	for(i=0;i<numallele;i++)
	{
		x=est_mu[i];
		est_freq[i]=x/tot_mu_est;
		
		y=tot_mu_est-x;
		varx=var_mu[i];
		vary=tot_mu_var-varx;
		var_freq[i]=(pow(y,2)*varx + pow(x,2)*vary)/pow(tot_mu_est,4);
		sd_freq[i]=sqrt(var_freq[i]);
	}
	

}
void est_var_calibrate(double *est_mu,double *var_mu, double *est_calibrate, double *var_calibrate, double *sd_calibrate)
{
	int x;
	*est_calibrate=0;
	for(x=0;x<numallele;x++)
		*est_calibrate+=est_mu[x];
	
	*var_calibrate=0;
	for(x=0;x<numallele;x++)
		*var_calibrate+=var_mu[x];
	*sd_calibrate=sqrt(*var_calibrate);

}

void est_var_mut(double *est_mu, double *var_mu, double *est_mut_freq, double *var_mut_freq, double *sd_mut_freq)
{
	int heterozygous = progenitors[0]!=progenitors[1];
	int i;
	double tot_mu_est,tot_mu_var, varx,vary,x,y;
	
	tot_mu_est=0;
	for(i=0;i<numallele;i++)
		tot_mu_est+=est_mu[i];
	tot_mu_var=0;
	for(i=0;i<numallele;i++)
		tot_mu_var+=var_mu[i];
	if(heterozygous)		// need to make sure this is correct
		x=tot_mu_est-est_mu[progenitors[0]]-est_mu[progenitors[1]];
	else
		x=tot_mu_est-est_mu[progenitors[0]];	// you sure we don't want to multiply this by 2?
	
	*est_mut_freq=x/tot_mu_est;
	
	if(!heterozygous)   // homozygous
	{
		y=tot_mu_est-x;
		varx=tot_mu_var-var_mu[progenitors[0]];
		vary=var_mu[progenitors[0]];
	
	}
	else
	{
		y = tot_mu_est - x;
		varx=tot_mu_var-var_mu[progenitors[0]] - var_mu[progenitors[1]];
		vary = var_mu[progenitors[0]] + var_mu[progenitors[1]];
	}
	*var_mut_freq= (pow(y,2)*varx + pow(x,2)*vary)/pow(tot_mu_est,4);
	*sd_mut_freq= sqrt(*var_mut_freq);

}