#include <stdio.h>
#include "generate.h"
#include "accumulate.h"
#include "randombinomial.h"
#include "suh.h"

extern int numruns,numallele;
extern int *allelesize;
extern double *expge;
extern int *replicates;
extern int **tableofalleles;
extern int progenitors[2];

extern _seen seen;
extern _seen unseen;
extern _freq freq;
extern _mu mu;
extern _mutant mutant;
extern _calibrate calibrate;
extern double truefreq[50];

double prob_seen[50][50];


void set_generate()
{
	int x,y;
	for(y=0;y<numruns;y++)
		for(x=0;x<numallele;x++)
		{
			printf(".");
			prob_seen[x][y]=seen.data[x][y]/(seen.data[x][y]+unseen.data[x][y]);
		}
	printf("done\n");
}

void generate()
{
	double prob;
	int generated,x,y,n;
	for(y=0;y<numruns;y++)
		for(x=0;x<numallele;x++)
		{
			n=replicates[y];
			prob=prob_seen[x][y];
			//printf("randbin(%d,%lf)",n,prob);
			generated=random_binomial(n,prob);
			seen.boot[x][y]=generated;
			unseen.boot[x][y]=replicates[y]-seen.boot[x][y];
		}
	
}

void boot_answers()
{
	int x;
	// mu
	for(x=0;x<numallele;x++)
		stats_from_accum(mu.esum.boot[x],mu.ess.boot[x],num_repeats,&mu.est.boot[x],&mu.var.boot[x],&mu.sd.boot[x]);
	// raw frequencies
	for(x=0;x<numallele;x++)
	{
		//printf("var[%d]=%lf  ",x,freq.var.untrans.boot[x]);
		stats_from_accum(freq.esum.untrans.boot[x], freq.ess.untrans.boot[x], num_repeats, &freq.est.untrans.boot[x], &freq.var.untrans.boot[x], &freq.sd.untrans.boot[x]);
		//	printf("var[%d]=%lf\n",x,freq.var.untrans.boot[x]);
	}
	// transformed frequencies
	for(x=0;x<numallele;x++)
		stats_from_accum(freq.esum.trans.boot[x], freq.ess.trans.boot[x], num_repeats, &freq.est.trans.boot[x], &freq.var.trans.boot[x], &freq.sd.trans.boot[x]);
	// raw calibrate
	stats_from_accum(calibrate.esum.boot, calibrate.ess.boot, num_repeats, &calibrate.est.boot, &calibrate.var.boot, &calibrate.sd.boot);
	// raw total mutants
	stats_from_accum(mutant.esum.untrans.boot, mutant.ess.untrans.boot, num_repeats, &mutant.est.untrans.boot, &mutant.var.untrans.boot, &mutant.sd.untrans.boot);
	// transformed total mutants
	stats_from_accum(mutant.esum.trans.boot, mutant.ess.trans.boot, num_repeats, &mutant.est.trans.boot, &mutant.var.trans.boot, &mutant.sd.trans.boot);

}